/*
 * Project: 12F675_UART_10_6
 * File:   12F675_UART_rev2.c
 * Author: Only Keypads
 *
 * Created on October 6, 2022, 7:58 PM
 */


#include <xc.h>
#pragma config FOSC = INTRCIO   // Oscillator Selection bits (INTOSC oscillator: I/O function on GP4/OSC2/CLKOUT pin, I/O function on GP5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-Up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = OFF      // GP3/MCLR pin function select (GP3/MCLR pin function is digital I/O, MCLR internally tied to VDD)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD disabled)
#pragma config CP = OFF         // Code Protection bit (Program Memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)

//Internal Crystal Oscillator
#define _XTAL_FREQ 4000000

//Define variables
#define UART_RX GP4     // High = Bus idle //Blue UART RX pin #3 on 12F675
#define UART_TX GP2     // High = Bus idle //Purple UART TX pin #5 on 12F675
#define LED GP5

int KEYAscii = 0x47; //Key ASCII received from keypad via PCF8574
int KeyTX; //Data to sent to UART Binary <01010101> Letter 'U'
  
// Main Function
void main()
{
        
    ANSEL = 0x00;     //Set ports as digital
    ADCON0 = 0x00;    //Shut off the A/D converter
    CMCON = 0x07;     //Shut off the comparator
    VRCON = 0x00;     //Shut off the voltage reference
    TRISIO = 0x18;    //GP2 output, GP3 input,GP4 input, GP5 output
    
    UART_TX=1; //Set TX Line High (Puts data line in standby))
    while(1)
    {
        //Blink routine
        LED=1; //Pin #2 (GP5) on 12F675
        __delay_ms(1000);            
        LED=0;
        __delay_ms(1000);
        if(LED==0){
        KeyTX = KEYAscii;    
        sendData(); //Jump to routine to send data to UART
       }
        
    }
    
     return;       
}

    sendData() //Send data to UART
{
    UART_TX=0; //Start bit send low to initiate receiver data transfer
    clock();
    
         // Send 'KeyAscii' bit #0 to UART // 
    if (KeyTX &(1<<0)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #1 to UART //
    if (KeyTX &(1<<1)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #2 to UART //
    if (KeyTX &(1<<2)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #3 to UART //
    if (KeyTX &(1<<3)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #4 to UART //
    if (KeyTX &(1<<4)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #5 to UART //
    if (KeyTX &(1<<5)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #6 to UART //
    if (KeyTX &(1<<6)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
         // Send 'KeyAscii' bit #7 to UART //
    if (KeyTX &(1<<7)){
    UART_TX=1;   
    }
    else{
     UART_TX=0;   
    }
    clock();
    
    //Send STOP BIT
    UART_TX=1; //Set "STOP Bit" HIGH 'End of Transmission
               //Also puts data line back to standby
    clock();
} 

//Clock subroutine
  clock()
{
__delay_ms(.516); //.516 mili seconds = 2400 baud

}//end clock loop
